/***************************************************************************
                          animator.h  -  description
                             -------------------
    begin                : Wed Jan 19 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef ANIMATOR_H
#define ANIMATOR_H

#include "graphic.h"

class Animation;
class Animator {
public: 
	Animator();
	~Animator();
	
  //Loads the script from file:
  bool create(Animation *animation_);

  //Returns the frame that should currently be used

	//for skins that have a direction:
	Graphic *get_current_frame(float newtime, float elevation, int dir);
	//for directionless animations:
	Graphic *get_current_frame(float newtime);

  //Finds a random sequence by this name and jumps to it
  bool start_sequence(char *sequence_name);

protected:
	Graphic *get_current_frame(float curtime_, int aim_id, int dir);
	Graphic *get_frame(int frame_id, int aim_id, int dir);
	bool goto_instruction(int instruction_index);

	//---------------------------------------------------------------------------
	//different pr instance:

	//the time the current frame started
	float last_frame_change;
	//the time the last frame was returned.
	float curtime;
	int current_instruction;
	int current_frame_id;

	Animation *animation;
};

#endif

