/***************************************************************************
                          event_target.h  -  description
                             -------------------
    begin                : Mon Feb 21 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef EVENT_TARGET_H
#define EVENT_TARGET_H

#include "event.h"

class Raw_surface;
class Event_target {
public:
	Event_target();
	virtual ~Event_target();

	//This does the routing of events
	// (the default is to let the event happen to this object)
	virtual bool handle(Event *event);

	//the different events that a target can handle:
	virtual bool handle_keyboard_key(Event_keyboard_key *key_event){return false;}
	virtual bool handle_mouse_key(Event_mouse_key *mouse_key_event){return false;}
	virtual bool handle_mouse_motion(Event_mouse_motion *mouse_motion_event){return false;}

  virtual void draw(Raw_surface *surface, int xpos_, int ypos_)=0;
  virtual void draw(Raw_surface *surface) {draw(surface,xpos,ypos);}
	void setpos(int xpos_, int ypos_);
	void setsize(int xsize_, int ysize_);
	void getsize(int &xsize_, int &ysize_);
	int getysize();

	bool isinside(int x,int y);
protected:
	int xpos;
	int ypos;
	int xsize;
	int ysize;
};

#endif

