/***************************************************************************
                          font_glyph.cpp  -  description
                             -------------------
    begin                : Sun Jan 30 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "font_glyph.h"
#include "systemheaders.h"
#include "fluff.h"

Font_glyph::Font_glyph()
{

}

Font_glyph::~Font_glyph()
{

}

bool Font_glyph::load_glyph(Graphics *graphics, char *font_root, char *spec_line, int32 color)
{
	if (sscanf(spec_line,"%i,%i,%i,%i",&ch,&advance,&bearing_x,&bearing_y) != 4) {
  	logmsg(lt_error,"The font spec line %s is invalid, unable to load glyph.",spec_line);
	 	return false;
	}

	char fn[400];
	sprintf(fn,"%s%i.rgbf",font_root,ch);
	Graphic *graphic = graphics->getgraphic(fn);
	if (!graphic)	return false;

	create(graphic);
 	return true;
}

int Font_glyph::put_glyph(Raw_surface *target, int &xpos, int ypos)
{
	draw_alpha(target,xpos+bearing_x,ypos-bearing_y);
	xpos += advance;
	return advance;
}


