/***************************************************************************
                          game_client.h  -  description
                             -------------------
    begin                : Thu Feb 3 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef GAME_CLIENT_H
#define GAME_CLIENT_H

#include "clientworld.h"
#include "loader.h"
#include "controls.h"
#include "tcp_client.h"
#include "viewport.h"
#include "graphic_bar.h"
#include "keymapper.h"

class Game_client {
public: 
	Game_client();
	~Game_client();

	//call to get things going:
	int init(Loader *loader_, Soundsystem *soundsystem_, const char *player_name_);
	int setgeom(int xpos_, int ypos_, int view_xsize, int view_ysize, int view_quality_);

	int join_game(const char *server, int server_port);
	//void get_join_status(char *text, int textsize, int &progress_, int &max_progress_); remember to have a semaphor

	//poll once for each frame:
	//it gets new data from the server and
	int think();

	bool handle_key(Nil_keyevent *keyevent);

	//call to have this game client draw it's view of the world
	int draw(Raw_surface *target);

	float get_trend_tick_duration() {return trend_tick_duration;}

	Controls controls;
  Clientworld clientworld;
	bool dropshadow;
	int last_update_size;
protected:
	float last_tick_time;
	float last_tick_duration;
	float trend_tick_duration;

	bool controls_ticked;
	void controls_tick();
	bool elevate_up;
	bool elevate_down;

	int xpos;
	int ypos;
	int view_quality;
	char *player_name;
	bool bars_at_top;
	//void set_join_status(char *text, int &progress_, int &max_progress_);

	Tcp_client tcp_client;
	Loader *loader;
	Soundsystem *soundsystem;
	Viewport *viewport;
	Graphic_bar health_bar;
	Graphic_bar weapon_bar[WEAPON_SLOTS];
};

#endif

