/***************************************************************************
                          graphic.cpp  -  description
                             -------------------
    begin                : Sun Oct 17 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "graphic.h"
#include "fluff.h"
#include "systemheaders.h"
#include "loader.h"

Graphic::Graphic() : Raw_surface()
{
}

Graphic::~Graphic()
{
}

bool Graphic::load(Loader *loader, char *name)
{	
  char *file = (char*)loader->getfile(name);
	if (!file) return false;
	
	Rgbf_header header;
	memcpy(&header,file,sizeof(header));

	//read old format:
	if ((unsigned)header.magic == RGBF_HEADER_MAGIC_OLD) {
		logmsg(lt_warning,"The file %s is in the old intel centric format, fix it!",name);
		attach(header.xsize,header.ysize,(int32 *)(file+sizeof(header)));
		return true;
	}

	//swap and read new format:	
	header.swap();
	if (header.magic == RGBF_HEADER_MAGIC) {
		attach(header.xsize,header.ysize,(int32 *)(file+sizeof(header)));
		return true;
	}

	logmsg(lt_error,"unable to load %s the magic is 0x%x, not 0x%x",name,header.magic,RGBF_HEADER_MAGIC);
	return false;	
}

void Graphic::maketransparent()
{
	for (int yc=0; yc < ysize; yc++)
		for (int xc=0; xc < xsize; xc++)
   		if (IS_OPAQUE(pixels[yc*xsize+xc]))
				pixels[yc*xsize+xc] = (pixels[yc*xsize+xc] & 0x0fffffff) | PF_ALPHA_BIT0 | PF_ALPHA_BIT1;
}
/*
s t r    rgb

v v v 3  -
h v h 2  -
e v e 2  -
s v s 2  -

v h H 3  b
h h h 2  -
e h e 2  s
s h s 2  s

v e E 3  t
h e h 2  b
e e e 2  -
s e s 2  s

v s S 1  t
h s S 1  t
e s S 1  t
s s s 1  s
*/











































