/***************************************************************************
                          icon_graph.cpp  -  description
                             -------------------
    begin                : Thu Jan 27 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "icon_graph.h"
#include "nil_math.h"
#include "fluff.h"

Icon_graph::Icon_graph()
{
}

Icon_graph::~Icon_graph()
{
}

void Icon_graph::init(int xpos_, int ypos_,int xsize_, int ysize_, int32 color_, int32 graphcolor_)
{
	create(xsize_,ysize_);
	color = color_;
	graphcolor = graphcolor_;
	xpos = xpos_;
	ypos = ypos_;
	draw_rectangle_raw(0,0,xsize,ysize,color);
}

void Icon_graph::addsample(float percent)
{
	//move all the pixels.
	{
		int32 *pixel = pixels;
		int32 *end = pixel+xsize*ysize;
		while (pixel < end) {
 	  	*pixel = *(pixel+1);
 	  	pixel++;
		}
	}

	//do the new column.
	if (percent < 0) percent = 0;
	if (percent > 1) percent = 1;
	int split = ysize-ROUND(ysize*percent);
	draw_vertical_line_raw(xsize-1,0,split,color);
	draw_vertical_line_raw(xsize-1,split,ysize,graphcolor);
}

void Icon_graph::draw(Raw_surface *target)
{
	draw_alpha(target,xpos,ypos);
}

