/***************************************************************************
                          loader.h  -  description
                             -------------------
    begin                : Sun Oct 17 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk

	

 ***************************************************************************/

#ifndef LOADER_H
#define LOADER_H

#include "graphics.h"
#include "fonts.h"
#include "animations.h"

class Loader_sources;
class Loader_files;
class Loader {
public:
	Loader();
	~Loader();

	/**
		returns >=0 on success
		This can accept either .lump files or directories as parameters,
		if a directory is specified, but not found it will try to load
		a lump file with the same name as the directory, but with .lump
		added.
	*/
	int addsource(char *path);	

	/**
		adds several sources in one go, separated by \t
	*/
	int addsources(const char *paths);	

	/**
		traditional copy:
		returns false on error.
	*/
	bool fileread(char *name, void *buffer, int buffer_size, int offset = 0);

	/**
		mmap()'ed direct access:
		returns a pointer to the file or NULL
	*/
	const void *getfile(char *name);

	/*
  	Gets the size of the file, returns -1 on error.
	*/
	int filesize(char *name);

	/*
  	Saving all the loaded data to a .lump:
		returns the number of bytes put into the buffer (<0 for error)
	*/
	int save_lump(char *buffer, int buffer_size);

	/*
		Highlevel caches, use these to access the kinds of data they
		manage.
	*/
	Graphics graphics;	
	Fonts fonts;
	Animations animations;
	//sounds?

protected:
	Loader_sources *sources;
	Loader_files *files;
};

#endif

