/***************************************************************************
                          menu.cpp  -  description
                             -------------------
    begin                : Sun Feb 20 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "menu.h"
#include "menu_item.h"
#include <vector>

class Menu_items : public std::vector<Menu_item *>{};

//-----------------------------------------------------------------------------
Menu::Menu()
{
	items = new Menu_items;
	item_index = 0;
	top_index = 0;
}

//-----------------------------------------------------------------------------
Menu::~Menu()
{
	delete items;
}

//-----------------------------------------------------------------------------
int Menu::get_total_item_height()
{
	int total = 0;
	Menu_items::iterator i = items->begin();
	while (i !=	items->end()) {
		total += (*i)->getysize();
  	i++;
	}
	return total;
}

//-----------------------------------------------------------------------------
bool Menu::handle(Event *event)
{
	//see if the selected item wants to deal with the event on it's own:
	Menu_items::iterator selected = items->begin() + item_index;
	if ((*selected)->isactive()) {
    return (*selected)->handle(event);
	}

	//route events to other objects
	Menu_items::iterator i = items->begin() + top_index;
	int curtop = 0;
	bool handled = false;
	while (i != items->end() && curtop <= ysize) {
		handled |= (*i)->handle(event);
		curtop += (*i)->getysize();
		i++;
	}

	handled |= event->happen(this);
	
	return handled;	
}

//-----------------------------------------------------------------------------
bool Menu::handle_keyboard_key(Event_keyboard_key *key_event)
{
  if (key_event->key_pressed()) {
		SDLKey key = key_event->keyboard_key->keysym.sym;

		switch (key) {
    	case SDLK_UP : break;


			default: break;
		}

	}
	return true;
}


//-----------------------------------------------------------------------------
const int MENU_ITEM_SPACING = 5;

//-----------------------------------------------------------------------------
void Menu::draw(Raw_surface *surface, int xpos_, int ypos_)
{
	//...
}

//-----------------------------------------------------------------------------
void Menu::draw_menu(Raw_surface *surface, int xpos_, int ypos_)
{
/*
	Menu_items::iterator selected = items->begin() + item_index;
	if ((*selected)->isactive()) {
    (*selected)->draw_menu(surface, xpos_, ypos_);
	}

	Menu_items::iterator i = menu_items->begin() + top_index;
	int curtop = 0;
	while (i != menu_items->end() && curtop <= ysize) {
		curtop += (*i)->getysize() + MENU_ITEM_SPACING;
		(*i)->draw(surface,xpos+MENU_ITEM_SPACING,ypos+curtop);
		i++;
	}
*/
}

