/***************************************************************************
                          obj_bignuke.cpp  -  description
                             -------------------
    begin                : Tue Feb 15 2000
    copyright            : (C) 2000 by Anders Rosendal
    email                : qute@klog.dk
 ***************************************************************************/


#include "obj_bignuke.h"
#include "obj_tinygranade.h"

Obj_bignuke::Obj_bignuke(World *world_, int id) :Obj_base(world_,id)
{
	sprite = NULL;
}

Obj_bignuke::~Obj_bignuke()
{
}

void Obj_bignuke::init(int owner, float xpos_, float ypos_, float xspeed_, float yspeed_, int count_, float power_)
{
	xpos=xpos_;
	ypos=ypos_;
	xspeed=xspeed_;
	yspeed=yspeed_;
	ownerid=owner;
	createtime=world->gettime();
	count=count_;
	power=power_;
	timer=3;
}

void Obj_bignuke::draw(Viewport *viewport)
{
	int x = ROUND(xpos)-viewport->xpos;
	int y = ROUND(ypos)-viewport->ypos;
	
	if (!sprite) {
		sprite = world->loader->graphics.getgraphic("obj/bignuke.rgbf");
		if (!sprite) return;
	}
	
	sprite->draw_view(viewport,x,y);
}

void Obj_bignuke::serialize(Serializer *serializer)
{
    Obj_base::serialize(serializer);
	serializer->rw(timer);
	serializer->rw(count);
	serializer->rw(power);
}

void Obj_bignuke::server_think()
{
	float x,y;
	Serverworld *serverworld = (Serverworld *)world;
	
	Map_hit hit = update_simple(true); //this calls client_think() for us and checks for collisions
	
	if (hit.hittype != ht_none) {
		net_dirty = true;
		bogo_bounce();
	}
	
	if(age()>timer) {
		done=true;
	    getpos(x,y);
	
		for(float angle =0; angle<2*PI; angle+=2*PI/(count+1)) {
			float bullet_angle = angle;
			Vector bullet_vector = rad2vector(bullet_angle);
			bullet_vector.scale(power);
//			knock_back_direction.add(bullet_vector);
	
//TODO: should the nuke make a spiral(like now) or a cirkel?
//TODO: make a array of vectors and choose(create) them random.
			
			Obj_tinygranade *bullet = (Obj_tinygranade *)serverworld->newobject(ot_tinygranade);
			if (bullet) {
					bullet->init(
					ownerid,
					x,y,
					xspeed+bullet_vector.x,
					yspeed+bullet_vector.y,
					40,
					8,
					0,
					42,
					true
				);
				//Say <bang!> here..
			}
		}
	}
}
