/***************************************************************************
                          obj_gib.cpp  -  description
                             -------------------
    begin                : Thu Nov 25 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "obj_gib.h"
#include <stdio.h>

Obj_gib::Obj_gib(World *world_, int id) :Obj_base(world_,id)
{
	rotate_speed = 5;
	puttomap = false;
	air_resistance = DEFAULT_DRAG;
	yaccel = DEFAULT_ACCEL;	
	radius = 1;
	frames[0] = NULL;
}

Obj_gib::~Obj_gib()
{
}

void Obj_gib::serialize(Serializer *serializer)
{
	Obj_base::serialize(serializer);

	serializer->rw(rotate_speed);
	serializer->rw(puttomap);
}

void Obj_gib::server_think()
{
	Map_hit hit = update_simple(); //client_think();
	if (puttomap) {
		done = true;
		return;
	}	
	if (hit.hittype != ht_none) {
		net_dirty = true;
		bogo_bounce();
		if (ABS(xspeed) < 0.01 && ABS(yspeed) < 0.01)
      puttomap = true;
	}
}

void Obj_gib::client_think()
{
	//make sure the graphics are loaded.
	if (!frames[0]) {
		for (int c=0; c<8; c++) {
			char gname[100];
			sprintf(gname,"misc/ripped_%i.rgbf",c+164);
			frames[c] = world->loader->graphics.getgraphic(gname);
		}
	}

/* come up with some non-fucked up gibs
	if (puttomap) {
  	int frame = ROUND(rotate_speed*age()) & 7;
  	if (!frames[frame]) {
  		logmsg("The graphic for the Obj_gib was not loaded, this is bad.",lt_error);
			return;
		}
		frames[frame]->map_draw(&world->map_buffer,&world->bgmap_buffer,ROUND(xpos),ROUND(ypos));
	}	
*/
	newton_update(world->gettime());
}

void Obj_gib::draw(Viewport *viewport)
{
	int x=ROUND(xpos-viewport->xpos);
	int y=ROUND(ypos-viewport->ypos);

	if (x >= 0 && x < viewport->get_xsize() &&
			y >= 0 && y < viewport->get_ysize()) {

	  int frame = ROUND(rotate_speed*age()) & 7;
 	 	if (!frames[frame]) {
 	 	logmsg(lt_error,"The graphic for the Obj_gib was not loaded, this is bad.");
			return;
		}
		frames[frame]->draw_view(viewport,x,y);
	}
}

void Obj_gib::init(float x, float y, float xspeed_, float yspeed_, int32 color)
{
	xpos = x;
	ypos = y;
	xspeed = xspeed_;
	yspeed = yspeed_;

	//use the color parameter to gennerate a gib with the correct color
}









