/***************************************************************************
                          obj_player_data.h  -  description
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef OBJ_PLAYER_DATA_H
#define OBJ_PLAYER_DATA_H

#include "obj_base.h"
#include "controls.h"
#include "all.h"
#include "netpackets.h"
#include "animator.h"

/**This class holds the cross-life data for players
  *@author Flemming Frandsen
  */

namespace SEQUENCE {
	const char INIT=0;		
	const char STOP=1;		
	const char WALK=2;		
	const char JUMP=3;		
	const char LAND=4;		
};

class Obj_player_data : public Obj_base  {
public: 
	public:
	virtual Object_type gettype() {return ot_player_data;}

	Obj_player_data(World *world_, int id);
	virtual ~Obj_player_data();

	virtual void serialize(Serializer *serializer);
 	virtual void server_think(); //this is where we handle respawning and stuff...
	
	void init(Net_joinrequest *joinrequest);

	//This object is purely for storing data, so the visual stuff doesn't apply:
	virtual void draw(Viewport *viewport){};
	virtual void client_think();

	Controls controls;

	int getavatarid() {return avatar_objectid;}
	int32 getcolor() {return color;}

	//stuff for accessing weapons:
	void set_weapon(int slot,Object_type object_type);
	Obj_weapon *get_weapon(int slot);

	Obj_player_avatar *get_player_avatar() {return (Obj_player_avatar *)world->get_object(avatar_objectid,ot_player_avatar);}

	Graphic *get_current_frame(char sequence);

	char *get_player_name() {return name;}

	protected:
	char current_sequence;

	void respawn();
	Animator *animator;
	bool anim_walking;

//synced data, start	
	Playername name;
	int32 color;
  int avatar_objectid;
	int	weapons[WEAPON_SLOTS];
//synced data, end

};

#endif




















