/***************************************************************************
                          obj_scoreboard.h  -  description
                             -------------------
    begin                : Sun Dec 26 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef OBJ_SCOREBOARD_H
#define OBJ_SCOREBOARD_H

#include "obj_base.h"

/**
  *@author Flemming Frandsenget_aimframe_size()
  */

class Obj_scoreboard : public Obj_base  {
public: 
	Obj_scoreboard(World *world_, int id);
	virtual ~Obj_scoreboard();
	
	virtual Object_type gettype() {return ot_scoreboard;}
	virtual void serialize(Serializer *serializer);

	//This object doesn't think, nor draw anything.
 	virtual void server_think(){}
	virtual void draw(Viewport *viewport){}
	virtual void client_think(){}

	void addfrag(int killer_id, int victim_id);

	//Getting the scores out again:
	typedef struct Score {
		int player_id;
  	int kills;
		int deaths;
		int frags;
		char playername[80];
	};

	Score getscore(int index);
	int getscore_count() {return scores_inuse;}
	
	void dump();
protected:
	int get_index(int player_id);
	
	Score scores[256];
	int scores_inuse;	
};

#endif


