/***************************************************************************
                          obj_weapon.h  -  description
                             -------------------
    begin                : Wed Dec 15 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef OBJ_WEAPON_H
#define OBJ_WEAPON_H

#include "obj_base.h"

/**
  *@author Flemming Frandsen
  */

class Obj_weapon : public Obj_base  {
public:
	Obj_weapon(World *world_, int id);
	virtual ~Obj_weapon();

	virtual Object_type gettype()=0;

	void init(int ownerid_);

	/**
		Users of weapons call this on the server to fire, fire calls dofire() to get the actual fireing done.
	*/
	bool fire(float x, float y, float aim_angle);
	
	bool canfire() {return (!reloading) && (readyness >= shot_cost);}

	// returns: 0..1, where 0=depleted and 1=fully ready
	float getreadyness() {return readyness;}

 	virtual void server_think();
	virtual void client_think(){};
	virtual void serialize(Serializer *serializer);
	virtual void draw(Viewport *viewport){};	//Object is always invisible
	bool verify();

protected:
	//This is what you need to implement to make a new weapon, it is called by fire()
	virtual void dofire(int x, int y, Vector aim_vector, float aim_angle)=0;

	Vector knock_back_direction; //Add the bullet speed to this
	float old_age;

	//semiconstants, to be set in the constructor of new weapons:
	float reload_speed;
	float shot_cost; 			//The amount of readyness spent fireing
	float reshoot_time; 	//Time between shots
	float last_shot_time;
	float knock_back; 		//Speed addition from one shot

	//synced:
	//ownerid
	float readyness;
	bool reloading;
};

#endif


















