/***************************************************************************
                          obj_weapon_megashotgun.cpp  -  description
                             -------------------
    begin                : Sun Jan 2 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "obj_weapon_megashotgun.h"
#include "fluff.h"
#include "all.h"

Obj_weapon_megashotgun::Obj_weapon_megashotgun(World *world_, int id) :Obj_weapon(world_, id)
{
	reload_speed = 0.1;
	shot_cost = 0.95;
	reshoot_time = 1.0;
	knock_back = 100.0;
}

Obj_weapon_megashotgun::~Obj_weapon_megashotgun()
{
}

const int BULLET_SPEED = 400;
const int BULLET_SPEED_SPREAD = 300;
const int BULLET_ANGLE_SPREAD = 150;
const int SUBSHOTS = 60;

void Obj_weapon_megashotgun::dofire(int x, int y, Vector aim_vector, float aim_angle)
{
	Serverworld *serverworld = (Serverworld *)world;

	for (int c=0;c<SUBSHOTS;c++) {

		float bullet_angle = aim_angle+rnd(-BULLET_ANGLE_SPREAD,BULLET_ANGLE_SPREAD)/1000.0;
		Vector bullet_vector = rad2vector(bullet_angle);
		bullet_vector.scale(rnd((1000-BULLET_SPEED_SPREAD/3)*BULLET_SPEED,(1000+BULLET_SPEED_SPREAD)*BULLET_SPEED)/1000.0);

		knock_back_direction.add(bullet_vector);
		
	 	Obj_projectile *bullet = (Obj_projectile *)serverworld->newobject(ot_projectile);
		if (bullet) {
			bullet->init(
				ownerid,
				x,y,
				xspeed+bullet_vector.x,
				yspeed+bullet_vector.y,
				30,
				8,
				2,
				0
			);
			//Say <bang!> here..
		}
	}
}




