/***************************************************************************
                          obj_weapon_plasmagun.cpp  -  description
                             -------------------
    begin                : Thu Feb 3 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "obj_weapon_plasmagun.h"
#include "all.h"

Obj_weapon_plasmagun::Obj_weapon_plasmagun(World *world_, int id) :Obj_weapon(world_,id)
{
	reload_speed = 0.2;
	shot_cost = 0.08;
	reshoot_time = 0.0;
	knock_back = 5.0;
}

Obj_weapon_plasmagun::~Obj_weapon_plasmagun()
{
}

const int BULLET_SPEED = 400;
const int BULLET_SPEED_SPREAD = 60;
const int BULLET_ANGLE_SPREAD = 20;
const int SUBSHOTS = 10;

void Obj_weapon_plasmagun::dofire(int x, int y, Vector aim_vector, float aim_angle)
{
	Serverworld *serverworld = (Serverworld *)world;
//	float frame_delta = world->get_last_frame_delta();

	for (int c=0;c<SUBSHOTS;c++) {

		int balltype = ROUND(0.5+3*readyness);
		if (c < 3) balltype-=rnd(0,1);
		if (c > 7) balltype+=rnd(0,1);

		float bullet_angle = aim_angle+rnd(-BULLET_ANGLE_SPREAD,BULLET_ANGLE_SPREAD)/1000.0;
		Vector bullet_vector = rad2vector(bullet_angle);
		bullet_vector.scale(rnd((1000-BULLET_SPEED_SPREAD/3)*BULLET_SPEED,(1000+BULLET_SPEED_SPREAD)*BULLET_SPEED)/1000.0);

		knock_back_direction.add(bullet_vector);
		
		Vector displacement=bullet_vector;
		displacement.normalize();
		displacement.scale(/*5*rnd(0,1)+*/c*0.1*BULLET_SPEED/SUBSHOTS);
	 	Obj_plasmaball *bullet = (Obj_plasmaball *)serverworld->newobject(ot_plasmaball);
		if (bullet) {
			bullet->init(
				ownerid,
				displacement.x+x,displacement.y+y,
				xspeed+bullet_vector.x,
				yspeed+bullet_vector.y,
				50,
				balltype
			);
			//Say <bang!> here..
		}
	}
}

