/***************************************************************************
                          serializer.h  -  description
                             -------------------
    begin                : Sat Jan 15 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef SERIALIZER_H
#define SERIALIZER_H

/**
  *@author Flemming Frandsen
  */

#include "raw_surface.h"

//headers identifying the next lump of data in a thought lump
typedef enum Thought_type {
	TT_OBJECT_STATE, 		//The package is the state of an object, object_type, object_id, object data
	TT_OBJECT_DELETE,		//delete an object
	TT_WORLD_STATE,			//The world state follows.
	TT_DEAD_PIXEL,			//Dead pixel to follow.

	TT_ERROR         		//used when a function returns error
};

class Serializer {
public: 
	Serializer();
	virtual ~Serializer();

	virtual bool isreading()=0;

//The simple datatypes:
	virtual void rw(char &value)=0;
	virtual void rw(int &value)=0;
	virtual void rw(int32 &value)=0;
	virtual void rw(bool &value)=0;
	virtual void rw(float &value)=0;
	virtual void rw(double &value)=0;
//The complex ones
	virtual void rwstr(char *value, int maxsize)=0;
	virtual void rwblob(char *blob, int size)=0;

  void dump();

	int getlength() { return buffer_inuse;}

	virtual int get_pos()=0;
	
protected:
	char *buffer;
	int buffer_size;
  int buffer_inuse;	
};

#endif

