/***************************************************************************
                          soundsystem.h  -  description
                             -------------------
    begin                : Mon Feb 21 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef SOUNDSYSTEM_H
#define SOUNDSYSTEM_H

#include "serializable.h"

/*
	This class should keep track of all the known samples and their sound_ids

	This is also the class that controls the


*/

class Sound_loaded;
class Sounds_loaded_name;
class Sounds_loaded_id;
class Loader;

class Soundsystem : public Serializable {
public: 
	Soundsystem(Loader *loader_);
	virtual ~Soundsystem();

	bool dirty;
	virtual void serialize(Serializer *serializer);

	int get_sample_id(char *sample_name);
	

	protected:

	int channels;
	bool quietmode;	
	Loader *loader;
	int next_sound_id;
	Sounds_loaded_name *sounds_loaded_name;
	Sounds_loaded_id   *sounds_loaded_id;
};

#endif

