/***************************************************************************
                          tcp_server.h  -  description
                             -------------------
    begin                : Sat Nov 13 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

#ifndef TCP_SERVER_H
#define TCP_SERVER_H

#include "tcp_server_connection.h"
#include "systemheaders.h"
#include "serverworld.h"
#include "update_queue.h"

#define MAX_CONNECTIONS 128

class Tcp_server {
public:
	Tcp_server_connection *connections[MAX_CONNECTIONS];
	int connections_inuse;	

	int bind_and_listen(int port, bool multithreaded_);
	void poll();

	Tcp_server();
	~Tcp_server();

	Serverworld *serverworld;

	bool ismultithreaded() {return multithreaded;}
	
  Update_queue update_queue;
	
	//This should be called from time to time to find
	//out what the oldest relevant update is and then have the updates_queue
	//recycle all serializers older than this.
	void recycle_serializers();

	void set_fudge(int normal_backlog, int abnormal_backlog, int max_wait_time);

protected:
	int net_normal_backlog;  	//Everything is ok as long as you don't get further behind than this
	int net_abnormal_backlog; //Kick clients that are this far behind.
	int net_max_wait_time; 		//the number of deca ms we wait for all clients to catch up.

	int server_socket;
	bool multithreaded;
};

#endif





















